<?php if (!defined('APPLICATION')) exit();
/*
Copyright 2008, 2009 Mark O'Sullivan
This file is part of Garden.
Garden is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
Garden is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with Garden.  If not, see <http://www.gnu.org/licenses/>.
Contact Mark O'Sullivan at mark [at] lussumo [dot] com
*/

/**
 * Renders a list of users who are taking part in a particular discussion.
 */
class WhosOnlineModule extends Module {
   
   protected $_OnlineUsers;
   
   public function __construct(&$Sender = '') {
      parent::__construct($Sender);
   }
   
   public function GetData() {
      $SQL = Gdn::SQL();
     // $this->_OnlineUsers = $SQL
     // insert or update entry into table
     $Session = Gdn::Session();
     
     if($Session->UserID)
        $SQL->Replace('Whosonline', array('UserID' => $Session->UserID, 'Timestamp' => time()), array('UserID' => $Session->UserID));
     
     
     $Frequency = Gdn::Config('WhosOnline.Frequency', 4) * 2;
     $History = time() - $Frequency;
     
     $this->_OnlineUsers = $SQL
        ->Select('u.Name')
        ->From('Whosonline w')
        ->Join('User u', 'w.UserID = u.UserID')
        ->Where('w.Timestamp >=', $History)
        ->OrderBy('u.Name')
        ->Get();
        
   }

   public function AssetTarget() {
      //return 'Foot';
      return 'Panel';
   }

   public function ToString() {
      $String = '';
      $Session = Gdn::Session();
      ob_start();
      ?>
      <div id="WhosOnline" class="Box">
         <h4><?php echo Gdn::Translate('Whos Online'); ?> (<span id="PeopleOnline"><?php echo $this->_OnlineUsers->NumRows(); ?></span> <?php echo Plural($this->_OnlineUsers->NumRows(), 'person', 'people')?>)</h4>
         <div class="WhosOnlinePanel">
             <?php if($this->_OnlineUsers->NumRows() > 0): ?>
                <?php $i = 1; ?>
                <?php foreach($this->_OnlineUsers->Result() as $User): ?>
                  <?php echo Anchor($User->Name, '/profile/'.$Session->UserID.'/'.urlencode($User->Name)); ?><?php echo ($i == $this->_OnlineUsers->NumRows()) ?  "" : ", "; ?>
                  <? $i++; ?>
                <?php endforeach; ?>
            <?php endif; ?>
         </div>
      </div>
      <?php
      $String = ob_get_contents();
      @ob_end_clean();
      return $String;
   }
}
